<template>
  <div class="app-container">
    <el-card class="topCard">
      <div class="topDiv">
        <span style="margin-left: 10px">工位号：</span>
        <el-select v-model="dataTypeValue" clearable placeholder="工位号" size="small" style="width:150px">
          <el-option
            v-for="item in dataType"
            :key="item.value"
            :label="item.label"
            :value="item.value"
          />
        </el-select>
        <!--        <span style="margin-left: 10px">变量类型：</span>-->
        <!--        <el-select v-model="valueTypeValue" placeholder="变量类型" clearable size="small" style="width:100px">-->
        <!--          <el-option-->
        <!--            v-for="item in valueType"-->
        <!--            :key="item.value"-->
        <!--            :label="item.label"-->
        <!--            :value="item.value"/>-->
        <!--        </el-select>-->
        <el-button
          icon="el-icon-search"
          plain
          size="small"
          style="margin-left: 5px"
          type="primary"
          @click="pageSize=50;pageCurrent=1;searchTable()"
        >查询
        </el-button>
        <!--        <el-button type="success" plain icon="el-icon-document-copy" size="small" @click="copyData('form4')">复制</el-button>-->
        <el-button icon="el-icon-upload2" plain size="small" type="info" @click="importOrder('form')">报警导入</el-button>
      </div>
      <el-table
        v-loading="loading"
        :data="tableData"
        border
        center
        height="740"
        highlight-current-row
        size="mini"
        style="width: 100%"
      >
        <el-table-column align="center" label="序号" width="60">
          <template slot-scope="scope">
            {{ scope.row.序号 }}
          </template>
        </el-table-column>
        <!--        <el-table-column label="TagID" align="center">-->
        <!--          <template slot-scope="scope">-->
        <!--            {{ scope.row.TagID }}-->
        <!--          </template>-->
        <!--        </el-table-column>-->
        <el-table-column align="center" label="TagName" width="200px">
          <template slot-scope="scope">
            {{ scope.row.TagName }}
          </template>
        </el-table-column>
        <el-table-column align="center" label="工位号">
          <template slot-scope="scope">
            {{ scope.row.工位号 }}
          </template>
        </el-table-column>
        <el-table-column align="center" label="地址">
          <template slot-scope="scope">
            【{{ scope.row.DbName }}】{{ scope.row.变量类型 }}{{ scope.row.变量地址 }} {{ scope.row.变量其它 }}
          </template>
        </el-table-column>
        <!--        <el-table-column label="测量位置" align="center">-->
        <!--          <template slot-scope="scope">-->
        <!--            {{ scope.row.测量位置 }}-->
        <!--          </template>-->
        <!--        </el-table-column>-->
        <el-table-column align="center" label="报警类型">
          <template slot-scope="scope">
            {{ scope.row.测量位置 }}
          </template>
        </el-table-column>
        <el-table-column align="center" label="报警内容" min-width="300px">
          <template slot-scope="scope">
            {{ scope.row.测量项目 }}
          </template>
        </el-table-column>
        <el-table-column align="center" label="操作" width="100">
          <template slot-scope="scope">
            <el-button
              icon="el-icon-edit"
              plain
              size="mini"
              type="text"
              @click="editShiftTable(scope.row)"
            >编辑
            </el-button>
          </template>
        </el-table-column>
      </el-table>
      <div class="block" style="margin-top: 10px;">
        <el-pagination
          v-if="!loading"
          :current-page="pageCurrent"
          :page-size="pageSize"
          :page-sizes="[50, 100, 200]"
          :total="total"
          layout="total, sizes, prev, pager, next, jumper"
          @size-change="handleSizeChange"
          @current-change="handleCurrentChange"
        />
      </div>
    </el-card>
    <el-dialog :title="title" :visible.sync="dialogFormVisible" center style="min-height: 200px;" width="400px">
      <el-form ref="form" :model="form" :rules="rules" label-position="right" label-width="110px">
        <el-form-item label="报警类型" prop="measurementItems" style="display: inline-block">
          <el-select v-model="form.measurementItems" placeholder="IP" size="small">
            <el-option
              v-for="item in alarmType"
              :key="item.value"
              :label="item.label"
              :value="item.value"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="报警内容" prop="valueName" style="display: inline-block">
          <el-input
            v-model="form.valueName"
            clearable
            placeholder="变量类型名称"
            size="small"
          />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button size="small" @click="callOff('form')">取消</el-button>
        <el-button size="small" type="primary" @click="submitAdd1('form')">确定</el-button>
      </div>
    </el-dialog>
    <el-dialog :visible.sync="dialogFormVisible3" center style="min-height: 200px" title="报警导入" width="900px">
      <div class="app-container">
        <upload-excel-component style="margin-left: 15%" @on-selected-file="selected"/>
        <div style="margin-left: 395px">
          <span v-show="worksheet.length > 1" style="cursor: pointer;width: 50px;" @click="removeAll"><i
            class="el-icon-close"
          /></span>
          <el-upload :file-list="itemFile" :on-remove="handleRemove" action="" style="width: 220px"/>
        </div>
        <div v-if="worksheet.length !== 0" style="margin: 3px 0 0 395px">
          <el-button icon="el-icon-upload2" size="small" type="primary" @click="basicPartsToSQL">导入到数据库
          </el-button>
        </div>
      </div>
    </el-dialog>
    <el-dialog :visible.sync="dialogFormVisible4" center style="min-height: 200px" title="数据复制" width="400px">
      <el-form ref="form1" :model="form4" :rules="rules4" label-position="right" label-width="110px">
        <el-form-item label="工位号" prop="engineTypeValue" style="display: inline-block">
          <el-select v-model="form4.engineTypeValue" placeholder="请选择工位号" size="small">
            <el-option
              v-for="item in dataType"
              :key="item.value"
              :label="item.label"
              :value="item.value"
              size="mini"
            />
          </el-select>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button size="small" @click="callOff4()">取消</el-button>
        <el-button size="small" type="primary" @click="submitAdd4()">确定</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import UploadExcelComponent from './UploadExcel.vue'
import request from '@/utils/request'
import { sleep } from '../../../utils/tool'

export default {
  name: 'UploadExcel',
  components: { UploadExcelComponent },
  data() {
    return {
      worksheet: [],
      itemFile: [],
      loading: false,
      tableData: [],
      err: 0,
      dataType: [], // 工位数组
      dataTypeValue: '', // 工位信息
      valueType: [
        {
          label: '基本变量',
          value: 8
        }, {
          label: '报警变量',
          value: 9
        }, {
          label: '质量变量',
          value: 7
        }
      ],
      valueTypeValue: '9',
      alarmType: [],
      alarmTypeValue: '',
      dialogFormVisible: false,
      dialogFormVisible4: false,
      form4: {
        engineTypeValue: ''
      },
      rules4: { // 订单下发验证
        engineTypeValue: [{ required: true, message: '请选择', trigger: 'blur' }]
      },
      title: '',
      dialogFormVisible3: false, // 订单导入
      form: {
        tagID: '',
        stationNo: '',
        measurementItems: '',
        valueName: ''
      },
      rules: { // 表单验证规则
      },
      total: 0, // 总条数
      pageList: 50, // 每页显示条数
      pageSize: 50, // 每页显示条数
      pageCurrent: 1 // 后台获取页
    }
  },
  created() {
    this.getNumber()
    this.getAlarmType()
  },
  methods: {
    // 初始化获取产品型号
    getNumber() {
      this.dataType = []
      request({
        url: '',
        method: 'post',
        data: {
          type: '3',
          name: `SELECT [工位号] FROM [dbo].[MES_计划BOM_工位与名称]`
        }
      }).then(response => {
        if (response.data.length) {
          this.dataTypeValue = response.data[0].工位号
          for (let i = 0; i < response.data.length; i++) {
            this.dataType.push({
              label: response.data[i].工位号,
              value: response.data[i].工位号
            })
          }
        }
      }).then(() => {
        this.searchTable()
      })
    }, // 初始化获取报警类型
    getAlarmType() {
      this.alarmType = []
      request({
        url: '',
        method: 'post',
        data: {
          type: '3',
          name: `SELECT [ID], [报警类型] FROM [dbo].[MES_基本变量_报警类型]`
        }
      }).then(response => {
        if (response.data.length) {
          // console.log(response.data, 'response.data')
          for (let i = 0; i < response.data.length; i++) {
            this.alarmType.push({
              label: response.data[i].报警类型,
              value: response.data[i].报警类型
            })
          }
        }
      })
    },
    searchTable() {
      this.loading = true
      this.tableData = []
      let stationNumberValue_check, valueType_check
      // this.engineTypeValue ? engineTypeValue_check = 1 : (engineTypeValue_check = 0, this.engineTypeValue = '')
      this.dataTypeValue ? stationNumberValue_check = 1 : (stationNumberValue_check = 0, this.dataTypeValue = '')
      this.valueTypeValue ? valueType_check = 1 : (valueType_check = 0, this.valueTypeValue = '')
      var param = []
      param[0] = ['变量类型_ischeck', valueType_check]
      param[1] = ['变量类型', this.valueTypeValue]
      param[2] = ['工位号_ischeck', stationNumberValue_check]
      param[3] = ['工位号', this.dataTypeValue]
      param[4] = ['PageCurrent', this.pageCurrent]
      param[5] = ['PageSize', this.pageSize]
      param[6] = ['PageCount', '1111', 'int', '1']
      param[7] = ['ItemCount', '1111', 'int', '1']
      var Data = this.CreateData('11', 'MES_基本变量_查询数据', param)
      this.ExecDatabase(Data).then(response => {
        console.log(response, 66)
        if (response.data.result.length !== 0) {
          this.tableData = response.data.result
        }
        this.total = parseInt(response.data.output[0].ItemCount)
        this.loading = false
      })
    },
    editShiftTable(row) {
      if (this.$refs['form'] !== undefined) {
        this.$refs['form'].resetFields()
      }
      this.form.tagID = row.TagID
      this.form.measurementItems = row.测量位置
      this.form.stationNo = row.工位号
      this.form.valueName = row.测量项目
      this.title = '编辑'
      this.dialogFormVisible = true
    },
    submitAdd1() {
      this.$refs['form'].validate((valid) => {
        if (valid) {
          var param = []
          param[0] = ['工位号', this.form.stationNo]
          param[1] = ['TagID', this.form.tagID]
          param[2] = ['测量项目', this.form.measurementItems]
          param[3] = ['变量类型名称', this.form.valueName]
          var Data = this.CreateData('12', '基础数据_报警变量维护_编辑', param)
          this.ExecDatabase(Data).then(response => {
            if (response.data[0].result === '1') {
              this.$message({
                message: '修改成功',
                type: 'success'
              })
              this.searchTable()
            } else {
              this.$message.error('修改失败！')
            }
          })
          this.dialogFormVisible = false
        } else {
          return false
        }
      })
    },
    callOff() {
      this.dialogFormVisible = false
    },
    copyData(formName) {
      if (this.tableData.length) {
        if (this.$refs[formName] !== undefined) {
          this.$refs[formName].resetFields()
        }
        this.dialogFormVisible4 = true
      } else {
        this.$message({
          message: '暂无可复制的数据！',
          type: 'error'
        })
      }
    },
    callOff4() {
      this.dialogFormVisible4 = false
    },
    submitAdd4() {
      var param = []
      param[0] = ['原始工位号', this.dataTypeValue]
      param[1] = ['复制工位号', this.form4.engineTypeValue]
      var Data = this.CreateData('12', '基础数据_报警变量维护_复制', param)
      this.ExecDatabase(Data).then(response => {
        if (response.data[0].result === '1') {
          this.$message({
            message: '修改成功',
            type: 'success'
          })
          this.dataTypeValue = this.form4.engineTypeValue
          this.searchTable()
          this.dialogFormVisible4 = false
        } else {
          this.$message.error('修改失败！')
        }
      })
      this.dialogFormVisible = false
    },
    // 分页
    handleSizeChange(val) {
      this.pageCurrent = 1
      this.pageSize = val
      this.searchTable()
    },
    handleCurrentChange(val) {
      this.pageCurrent = val
      this.searchTable()
    },
    // 导入订单
    importOrder() {
      this.dialogFormVisible3 = true
    },
    removeAll() {
      this.worksheet = []
      this.itemFile = []
    },
    async selected(data) { // 选择需要导入的文件
      console.log(data, 1111)
      this.worksheet = data.worksheet // 获取每个多选文件的表格坐标及值
      this.itemFile = data.itemFile
    },
    handleRemove(file) { // 移除文件
      for (let i = 0; i < this.itemFile.length; i++) {
        if (this.itemFile[i].name === file.name) {
          this.worksheet.splice(i, 1)
          this.itemFile.splice(i, 1)
        }
      }
    },
    async basicPartsToSQL() {
      try {
        this.loading = true
        this.err = 0
        console.log(this.worksheet.length, 'this.worksheet.length')
        for (let j = this.worksheet.length - 1; j >= 0; j--) {
          console.log('jjjjjjjjjjjjjjjj', j)
          let text,
            position,
            OpName
          console.log(this.worksheet[j])
          OpName = this.worksheet[j][`A${1}`] ? this.worksheet[j][`A${1}`].v : ''
          OpName = OpName.split(':')[0]
          console.log('OpName', OpName)
          for (let i = 0; i < 500; i++) {
            const attr = i + 2
            text = this.worksheet[j][`A${attr}`] ? this.worksheet[j][`A${attr}`].v : ''
            position = this.worksheet[j][`B${attr}`] ? this.worksheet[j][`B${attr}`].v : ''
            if (text !== '' && position !== '') {
              // 执行存储过程进行覆盖报警变量
              await sleep(50)
              console.log(text, position, OpName)
              await this.insertToSQL(text, position, OpName)
            }
            // if (!sort && !orderNumber && !productModel && !numberPlan && !startDate && !endDate) {
            //   break
            // } else if (!orderNumber) { // 名称不能为空
            //   this.$notify.error(`订单号不能为空`)
            //   break
            // } else if (Number(numberPlan) <= 0) { // 数量不能为0
            //   this.$notify.error(`计划数量不能为空`)
            //   break
            // } else {
            //   if (orderNumber) {
            //     await sleep(50)
            //     await this.insertToSQL(sort, orderNumber, productModel, numberPlan, startDate, endDate)
            //   } else {
            //     this.loading = false
            //     this.disabled = false
            //     this.$notify.error(`请确认导入文件是否正确`)
            //     return
            //   }
            // }
          }
          this.itemFile.splice(j, 1)
          this.worksheet.splice(j, 1)
          this.err === 0 ? this.$message.success(`导入完成`) : this.$message.error(`导入失败零件个数为${this.err}，请检查文件是否正确`)
        }
        this.loading = false
        this.searchTable()
      } catch (e) {
        this.err++
        this.loading = false
        this.$notify.error(`导入数据错误,请检查导入文件是否正确`)
        console.log(`导入数据错误${e}`)
      }
    },
    async insertToSQL(text, position, OpName) {
      try {
        var param = []
        param[0] = ['工位号', OpName]
        param[1] = ['文本', text]
        param[2] = ['地址位置', position]
        var Data = this.CreateData('12', '报警变量_导入', param)
        const response = await this.ExecDatabase(Data)
        const res = response.data
        if (Object.prototype.hasOwnProperty.call(res, 'output') === false) {
          if (res[0].result === '0') {
            this.$notify.error(`${OpName}, ${position}导入失败`)
          }
        } else {
          if (res.result[0].result === '0') {
            this.$notify.error(`${OpName}, ${position}导入失败`)
          }
          if (res.output[0].导入类型 === '2') {
            this.$notify.warning(`${OpName}, ${position}存在重复数据`)
          }
        }
      } catch (e) {
        this.err++
        this.$message.error(`导入数据错误`)
        console.log(`导入数据错误${e}`)
      }
    }
  }
}
</script>

<style scoped>
.topDiv {
  margin-bottom: 10px;
}
</style>
